<?php

// ■振り仮名チェック
function dreamphp_furigana($submit_check,$dream_option,$dream_myName_data)
{
	$my_post = (isset($_POST['onName'])) ? $_POST['onName'] : $_POST['myName']; 
	if($submit_check === 1 && extension_loaded('mbstring'))
	{
		foreach($my_post as $i => $myName)
		{
			if(isset($dream_myName_data[$i]['furigana']))
			{
				if(!preg_match("/^[ぁ-んァ-ヶヽー]+$/u", mb_convert_kana($myName, "HVc", DREAM_CHARSET) )&&
				$myName !== $dream_myName_data[$i]['item'] &&
				$myName !== $dream_myName_data[$i]['defName'] &&
				$myName !== '未登録' && 
				$myName !== '' 
			)
				{
					dream_header_html();
					$position = (isset($_POST['position']) && $_POST['position']!=='') ? $_POST['position'] : '';
					echo'<p>フリガナ項目に漢字やアルファベットは登録できません。登録内容を確認してください。';
					nameForm($position, '', $dream_myName_data, $dream_option, 'furigana');
					exit;
				}
			}
		}
	}
}

function furiJS($dream_option=FALSE, $dream_myName_data=FALSE)
{
	$dreamjs = '';
	$match_list = 'dream_val_check != "" && !dream_val_check.match( /^[ぁ-んァ-ヶー]+$/ )';
	if($dream_option['form_first'] == '0')
	{
		foreach($dream_myName_data as $i => $v)
		{
			if(isset($v['furigana'])){ $f_changeList[] = $v['item']; }
		}
		$match_list .= '&& !dream_val_check.match(/^(';
		$match_list .= implode('|', $f_changeList);
		$match_list .= ')$/)';
	}
	elseif($dream_option['form_first'] == '1'){ $match_list .= ' && dream_val_check != "未登録"'; }
	$dreamjs .= <<<__EOD
function check(obj) {
	const dream_val_check = obj.value;
	if($match_list){
		alert('ふりがな項目はひらがなかカタカナのみで入力してください');
		setTimeout(function(){ obj.focus(); }, 1);
	}
}

__EOD;

	return $dreamjs;
}

// ■名前カスタム表示
function CmyName($no='0', $type='', $kigou='…',$pre=FALSE)
{
	global $dream_myName_data,$dream_ini,$dream_option;
	$no = trim($no);
	if(isset($dream_myName_data[$no]))
	{
		if($dream_myName_data[$no]['defName'] === $dream_myName_data[$no]['set'] && 
			$pre !== FALSE && $pre !== ''
		){
			$nameSet = trim($pre);
		}else{
			$nameSet = (isset($dream_myName_data[$no]['set']) && $dream_myName_data[$no]['set'] !== '') ? trim($dream_myName_data[$no]['set']) : '';
		}
	}
	if(isset($nameSet) && $nameSet !== '' && $type!=='' && extension_loaded('mbstring')){
	
		mb_regex_encoding(DREAM_CHARSET);
		$name = '';
		$Moji = array();
		$bMoji = array();
		$stop   = mb_strlen($nameSet);

		if(ctype_alpha($nameSet)) //登録が半角英字だけなら
		{
			$Moji = str_split($nameSet);
			$name = $nameSet;
		}
		else //それ以外（全角を含むなら）
		{

			$restate = function($str,$boin){ //カタカナに戻す
				if(preg_match('/^[ァ-ヾ]+$/u', $str)){
					return mb_convert_kana($boin,"C", DREAM_CHARSET);
				}
				return $boin;
			};

			//指定の文字を一字分に含める
			$Moji = preg_split("/(?![ゃ|ゅ|ょ|っ|ぁ|ぃ|ぅ|ぇ|ぉ|ゎ|ャ|ュ|ョ|ッ|ァ|ィ|ゥ|ェ|ォ|ヮ|ー])/u", $nameSet, -1, PREG_SPLIT_NO_EMPTY);

			foreach($Moji as $i => $mj) //母音セット
			{
				switch (mb_convert_kana(mb_substr($mj,-1), 'c', DREAM_CHARSET)){
					case 'あ': case 'か': case 'が': case 'さ': case 'ざ': case 'た': case 'だ':
					case 'な': case 'は': case 'ば': case 'ぱ': case 'ま': case 'や': case 'ら': case 'わ':
					case 'ゃ': case 'ゎ':
						$bMoji[] = $restate($mj,'ぁ'); break;
					case 'い': case 'き': case 'ぎ': case 'し': case 'じ': case 'ち': case 'ぢ':
					case 'に': case 'ひ': case 'び': case 'ぴ': case 'み': case 'ゐ': case 'り':
						$bMoji[] = $restate($mj,'ぃ'); break;
					case 'う': case 'く': case 'ぐ': case 'す': case 'ず': case 'つ': case 'づ': 
					case 'ぬ': case 'ふ': case 'ぶ': case 'ぷ': case 'む': case 'ゆ': case 'る':
					case 'ゅ':
						$bMoji[] = $restate($mj,'ぅ'); break;
					case 'え': case 'け': case 'げ': case 'せ': case 'ぜ': case 'て': case 'で': 
					case 'ね': case 'へ': case 'べ': case 'ぺ': case 'め': case 'ゑ': case 'れ':
						$bMoji[] = $restate($mj,'ぇ'); break;
					case 'お': case 'こ': case 'ご': case 'そ': case 'ぞ': case 'と': case 'ど': 
					case 'の': case 'ほ': case 'ぼ': case 'ぽ': case 'も': case 'よ': case 'ろ': case 'を':
					case 'ょ':
						$bMoji[] = $restate($mj,'ぉ'); break;
					default:
						$bMoji[] = '';
				}
			}
			foreach($Moji as $i => $v){  //母音
				if(strpos($type,'B')!== false){ $name .= $v.$bMoji[$i]; $Moji[$i] .= $bMoji[$i]; }
				else{ $name .= $v; }
			}
		}


		//記号セット
		if(isset($kigou) && $kigou === 's' && isset($bMoji[0])){ $kigou = $bMoji[0]; }
		else { $kigou = (isset($kigou) && $kigou !='') ? htmlspecialchars($kigou, ENT_QUOTES, DREAM_CHARSET) : '…'; }

		//変形
		$dname = '';
			if(strpos($type,'d')!== false) { $dname = $Moji[0].$kigou.$name; } //どもり
		elseif(strpos($type,'c')!== false) { foreach($Moji as $v){ $dname .= $v.$kigou; } } //区切り
		elseif(strpos($type,'t')!== false) { foreach($Moji as $i=> $v){ $dname .= ($i=='0') ? $v.$kigou : $v; } } //途切れ
		elseif(strpos($type,'p')!== false) { $dname = mb_substr($name,0,1); } //1文字目
		elseif(strpos($type,'q')!== false) { $dname = mb_substr($name, 1, $stop); } //1文字目以外

		elseif(strpos($type,'n')!== false) { $dname = $Moji[0]; } //初1字
		elseif(strpos($type,'m')!== false) { $dname = (isset($Moji[1])) ? $Moji[0].$Moji[1] : $Moji[0]; } //初2字
		elseif(strpos($type,'f')!== false) { $dname = $Moji[count($Moji) - 1]; } //終1字
		elseif(strpos($type,'e')!== false) { $Moji = array_reverse($Moji); $dname = (isset($Moji[1])) ? $Moji[1].$Moji[0] :  $Moji[0]; } //終2字
		elseif(strpos($type,'i')!== false) { $dname = mb_substr($name, 0, $stop-1); } //終1字以外
		elseif(strpos($type,'a')!== false) { //あだな
			if(empty($Moji[2])){ $dname = $Moji[0].$kigou; }
			else{ $dname = $Moji[0].$Moji[1]; }
		}
		elseif(strpos($type,'s')!== false) { //最後の母音
			$lb = $bMoji[count($bMoji) - 1]; 
			$dname = (isset($lb)) ? $lb : ''; 
		} 

		$name = (isset($dname) && $dname !== '') ? $dname : $name;

		if(ctype_alpha($name)) //アルファベット
		{
			if(strpos($type,'A')!== false) { $name = strtoupper($name); } //大文字
			elseif(strpos($type,'Z')!== false) { $name = strtolower($name); } //小文字
			elseif(strpos($type,'U')!== false) { $name = ucfirst(strtolower($name)); } //最初だけ大文字
		}
		else //ふりがな
		{
			if(strpos($type,'K')!== false) { $name = mb_convert_kana($name, 'C', DREAM_CHARSET); } //カタカナ
			if(strpos($type,'H')!== false) { $name = mb_convert_kana($name, 'c', DREAM_CHARSET); } //平仮名
			if(strpos($type,'r')!== false) { $name = mb_convert_kana($name, 'akh', DREAM_CHARSET); } //半角
		}
	}
	else{ 
		$name = '<strong>ERROR</strong>';
	}

	echo $name;
} 

// ■クッキーオフの場合
function offForm($small_form=FALSE, $this_action=FALSE, $dream_myName_data=FALSE, $dream_option=FALSE)
{
	global  $dream_myName_data,$dream_option;
	if(
		($dream_option['post_on'] === '1' || $dream_option['post_on'] === '2') 
		&& empty($_COOKIE['check']) && empty($_COOKIE['myName']) 
		&& empty($_POST['onName'])
	)
	{
		dream_header_html();
		nameForm($small_form, '', $dream_myName_data, $dream_option, 'post_on');
		exit;
	}
}
